export interface SignalBinding {
    setActive(value: boolean): void;
    isActive(): boolean;
    detach(): void;
}
export declare type SignalCallback<T = unknown> = (param: T) => void;
export declare class Signal<T = unknown> {
    private head?;
    private tail?;
    private isDispatching;
    private detachAllFlag;
    private detachRequests?;
    private addRequests?;
    await(): Promise<T>;
    add(callback: SignalCallback<T>, context?: unknown, once?: boolean): SignalBinding;
    addOnce(callback: SignalCallback<T>, context?: unknown): SignalBinding;
    dispatch(param?: T): void;
    detachAll(): void;
    private doAdd;
    private processDetachRequests;
    private processAddRequests;
    private removeBinding;
    private doRemoveBinding;
}
export declare const signalGroup: () => {
    add: <T extends any>(signal: Signal<T>, callback: (param: T) => void) => void;
    dispose: () => void;
    setActive: (active: boolean) => void;
};
